#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
Author: Li Yuanming
Email: yuanmingleee@gmail.com
Date: May 30, 2023
"""
RED_BACKGROUND_COLOR = '#fff1f0'
RED_COLOR = '#cf1322'
RED_BORDER_COLOR = '#ffa39e'
ORANGE_BACKGROUND_COLOR = '#fff7e6'
ORANGE_COLOR = '#d46b08'
ORANGE_BORDER_COLOR = '#ffd591'
GREEN_BACKGROUND_COLOR = '#f6ffed'
GREEN_COLOR = '#389e0d'
GREEN_BORDER_COLOR = '#b7eb8f'
BLUE_BACKGROUND_COLOR = '#e6f7ff'
BLUE_COLOR = '#096dd9'
BLUE_BORDER_COLOR = '#91d5ff'
MEGENTA_BACKGROUND_COLOR = '#fff0f6'
MEGENTA_COLOR = '#531dab'
MEGENTA_BORDER_COLOR = '#f759ab'
PURPLE_BACKGROUND_COLOR = '#f9f0ff'
PURPLE_COLOR = '#c41d7f'
PURPLE_BORDER_COLOR = '#ffadd2'
VOLCANO_BACKGROUND_COLOR = '#fff2e8'
VOLCANO_COLOR = '#d4380d'
VOLCANO_BORDER_COLOR = '#ffbb96'
GOLD_BACKGROUND_COLOR = '#fffbe6'
GOLD_COLOR = '#d48806'
GOLD_BORDER_COLOR = '#ffe58f'
LIME_BACKGROUND_COLOR = '#fcffe6'
LIME_COLOR = '#7cb305'
LIME_BORDER_COLOR = '#eaff8f'
CYAN_BACKGROUND_COLOR = '#e6fffb'
CYAN_COLOR = '#08979c'
CYAN_BORDER_COLOR = '#87e8de'
GEEKBLUE_BACKGROUND_COLOR = '#e6f7ff'
GEEKBLUE_COLOR = '#1d39c4'
GEEKBLUE_BORDER_COLOR = '#adc6ff'

DEFAULT_BACKGROUND_COLOR_SEQUENCE = [
    RED_BACKGROUND_COLOR,
    ORANGE_BACKGROUND_COLOR,
    GREEN_BACKGROUND_COLOR,
    BLUE_BACKGROUND_COLOR,
    MEGENTA_BACKGROUND_COLOR,
    PURPLE_BACKGROUND_COLOR,
    VOLCANO_BACKGROUND_COLOR,
    GOLD_BACKGROUND_COLOR,
    LIME_BACKGROUND_COLOR,
    CYAN_BACKGROUND_COLOR,
    GEEKBLUE_BACKGROUND_COLOR,
]
DEFAULT_COLOR_SEQUENCE = [
    RED_COLOR,
    ORANGE_COLOR,
    GREEN_COLOR,
    BLUE_COLOR,
    MEGENTA_COLOR,
    PURPLE_COLOR,
    VOLCANO_COLOR,
    GOLD_COLOR,
    LIME_COLOR,
    CYAN_COLOR,
    GEEKBLUE_COLOR,
]

DEFAULT_BORDER_COLOR_SEQUENCE = [
    RED_BORDER_COLOR,
    ORANGE_BORDER_COLOR,
    GREEN_BORDER_COLOR,
    BLUE_BORDER_COLOR,
    MEGENTA_BORDER_COLOR,
    PURPLE_BORDER_COLOR,
    VOLCANO_BORDER_COLOR,
    GOLD_BORDER_COLOR,
    LIME_BORDER_COLOR,
    CYAN_BORDER_COLOR,
    GEEKBLUE_BORDER_COLOR,
]

text_uncolorable_format_template = "<span style='color:{color};background-color:{background_color};" \
                                   "border:2px solid;border-color:{border_color};border-radius:2px;" \
                                   "padding:1px 8px;'>{text}</span>"


def tag(text=None, variation='green'):
    color_mapper = {
        'red': (RED_COLOR, RED_BACKGROUND_COLOR, RED_BORDER_COLOR),
        'orange': (ORANGE_COLOR, ORANGE_BACKGROUND_COLOR, ORANGE_BORDER_COLOR),
        'green': (GREEN_COLOR, GREEN_BACKGROUND_COLOR, GREEN_BORDER_COLOR),
        'blue': (BLUE_COLOR, BLUE_BACKGROUND_COLOR, BLUE_BORDER_COLOR),
        'megenta': (MEGENTA_COLOR, MEGENTA_BACKGROUND_COLOR, MEGENTA_BORDER_COLOR),
        'purple': (PURPLE_COLOR, PURPLE_BACKGROUND_COLOR, PURPLE_BORDER_COLOR),
        'volcano': (VOLCANO_COLOR, VOLCANO_BACKGROUND_COLOR, VOLCANO_BORDER_COLOR),
        'gold': (GOLD_COLOR, GOLD_BACKGROUND_COLOR, GOLD_BORDER_COLOR),
        'lime': (LIME_COLOR, LIME_BACKGROUND_COLOR, LIME_BORDER_COLOR),
        'cyan': (CYAN_COLOR, CYAN_BACKGROUND_COLOR, CYAN_BORDER_COLOR),
        'geekblue': (GEEKBLUE_COLOR, GEEKBLUE_BACKGROUND_COLOR, GEEKBLUE_BORDER_COLOR),
    }
    color, background_color, border_color = color_mapper.get(variation)
    return text_uncolorable_format_template.format(
        color=color,
        background_color=background_color,
        border_color=border_color,
        text=text
    )
